package myutil;
import commandcenter.CommandCenter;
import enumerate.Action;
import enumerate.State;
import simulator.Simulator;
import structs.CharacterData;
import structs.FrameData;
import structs.GameData;
public class MacheteSimulator {
	public static Action getAction(FrameData fd,GameData gd,boolean player){
		Simulator simulator=gd.getSimulator();
		FrameData frameData = simulator.simulate(fd, player, null, null, 17);


		CommandCenter cc=new CommandCenter();cc.setFrameData(frameData, player);
		int distance = cc.getDistanceX();
		int energy = frameData.getMyCharacter(player).getEnergy();
		CharacterData my = cc.getMyCharacter();
		CharacterData opp = cc.getEnemyCharacter();
		int xDifference = my.x - opp.x;

			// Following is the brain of the reflex agent. It determines distance to the enemy
			// and the energy of our agent and then it performs an action
			if ((opp.energy >= 300) && ((my.hp - opp.hp) <= 300))
				return Action.FOR_JUMP;
				// if the opp has 300 of energy, it is dangerous, so better jump!!
				// if the health difference is high we are dominating so we are fearless :)
			else if (!my.state.equals(State.AIR) && !my.state.equals(State.DOWN)) { //if not in air
				if ((distance > 150)) {
					return Action.FOR_JUMP; //If its too far, then jump to get closer fast
				}
				else if (energy >= 300)
					return Action.STAND_D_DF_FC; //High energy projectile
				else if ((distance > 100) && (energy >= 50))
					return Action.STAND_D_DB_BB; //Perform a slide kick
				else if (opp.state.equals(State.AIR)) //if enemy on Air
					return Action.STAND_F_D_DFA; //Perform a big punch
				else if (distance > 100)
					return Action.DASH;// Perform a quick dash to get closer
				else
					return Action.STAND_B; //Perform a kick in all other cases, introduces randomness
			}
			else if ((distance <= 150) && (my.state.equals(State.AIR) || my.state.equals(State.DOWN))
					&& (((gd.getStageXMax() - my.x)>=200) || (xDifference > 0))
					&& ((my.x >=200) || xDifference < 0)) { //Conditions to handle game corners
				if (energy >= 5)
					return Action.AIR_DB; // Perform air down kick when in air
				else
					return Action.AIR_B; //Perform a kick in all other cases, introduces randomness
			}
			else
			{
				if(my.state==State.AIR)
					return Action.AIR_B;
				else
					return Action.STAND_B; //Perform a kick in all other cases, introduces randomness
			}

	}
}
