/*******************************************************************************
 * HTN Fighter 
 * Created by Xenija Neufeld, 2017
 ******************************************************************************/
package HTNPlanner.Methods.Combos;

import java.util.Vector;

import enumerate.Action;
import mizunoAI_simulator.SimCharacter;
import structs.MotionData;
import util.Pair;
import HTNPlanner.Method;
import HTNPlanner.Planner;
import HTNPlanner.CompoundTasks.*;
import HTNPlanner.PrimitiveTasks.*;

public class m_FourthHit_STAND_F_D_DFA extends Method 
{
	public m_FourthHit_STAND_F_D_DFA()
	{
		super();
		
		this.name = "m_FourthHit_STAND_F_D_DFA";
		this.tasksToDecompose.add(new c_MoveInActionRange(Action.STAND_F_D_DFA));
		this.tasksToDecompose.add(new p_STAND_F_D_DFA());
	}
	
	@Override
	public boolean CheckPreconditions(Pair<SimCharacter, SimCharacter> currentSimCharacters) 
	{
		boolean holds = true;
		//if(currentSimCharacters.m_a.getHitNumber() != 1)
		if(currentSimCharacters.m_a.GetPrevActions().size() != 3)
		{
			holds = false;
			return holds;
		}
		
		//stand b a a - fddfa
		if(currentSimCharacters.m_a.GetPrevActions().getFirst() != Action.STAND_B)
		{
			holds = false;
			return holds;
		}
			
		//stand b a a - fddfa
		if(currentSimCharacters.m_a.GetPrevActions().getLast() != Action.STAND_A)
		{
			holds = false;
		}

				
		return holds;
	}
}
